Name: kernel-image-xen-dom0
Version: 2.6.18
Release: alt6.M40.3
Packager: Michail Yakushin <silicium@altlinux.ru>
%define kernel_base_version	%version
%define kernel_extra_version	%nil
# Numeric extra version scheme developed by Alexander Bokovoy:
# 0.0.X -- preX
# 0.X.0 -- rcX
# 1.0.0 -- release
%define kernel_extra_version_numeric 1.0.0

%define krelease	%release

%define flavour		%( s='%name'; printf %%s "${s#kernel-image-}" )
%define base_flavour	%( s='%flavour'; printf %%s "${s%%%%-*}" )
%define sub_flavour	%( s='%flavour'; printf %%s "${s#*-}" )

# Build options
# You can change compiler version by editing this line:
%define kgcc_version	4.1

# Enable/disable SGML docs formatting
%def_enable docs

## Don't edit below this line ##################################

%define kversion	%kernel_base_version%kernel_extra_version
%define modules_dir	/lib/modules/%kversion-%flavour-%krelease

%define kheaders_dir	%_prefix/include/linux-%kversion-%flavour
%define kbuild_dir	%_prefix/src/linux-%kversion-%flavour-%krelease
%define old_kbuild_dir	%_prefix/src/linux-%kversion-%flavour

Summary: The Linux kernel (the core of the Linux operating system)
License: GPL
Group: System/Kernel and hardware
Url: http://www.kernel.org/


Patch0: %name-%version-%release.patch

ExclusiveArch: i586 x86_64

ExclusiveOS: Linux

BuildRequires: dev86 flex
BuildRequires: libdb4-devel
BuildRequires: gcc%kgcc_version
BuildRequires: kernel-source-%kernel_base_version = %kernel_extra_version_numeric
BuildRequires: kernel-build-tools >= 0.8, module-init-tools >= 3.1

%if_enabled docs
BuildRequires: xmlto transfig ghostscript
%endif

%if_enabled ccache
BuildRequires: ccache
%endif

%ifdef use_ccache
BuildRequires: ccache
%endif

Requires: bootloader-utils >= 0.3-alt1
Requires: module-init-tools >= 3.1
Requires: mkinitrd >= 1:2.9.9-alt1
Requires: startup >= 0.8.3-alt1

Provides: kernel = %kversion

Prereq: coreutils
Prereq: module-init-tools >= 3.1
Prereq: mkinitrd >= 1:2.9.9-alt1

%description
This package contains the Linux kernel that is used to boot and run
your system.

The "xen026" variant of kernel packages is a XenLinux kernel which 
contains hardware device drivers and drivers for Xen's virtual devices.

Xen is an open-source para-virtualizing virtual machine monitor (VMM), 
or 'hypervisor', for the x86 processor architecture. Xen can securely
execute multiple virtual machines on a single physical system with
close-to-native performance.

%package -n kernel-headers-%flavour
Summary: Header files for the Linux kernel
Group: System/Kernel and hardware
Requires: kernel-headers-common >= 1.1.5
Provides: kernel-headers = %version
Provides: kernel-headers-%base_flavour = %version-%release

%description -n kernel-headers-%flavour
This package makes Linux kernel headers corresponding to the Linux
kernel package %name-%version-%release available for building
userspace programs (if this version of headers is selected by
adjust_kernel_headers).

Since Linux 2.6.18 the kernel build system supports creation of
sanitized kernel headers for use in userspace (by deleting headers
which are not usable in userspace and removing #ifdef __KERNEL__
blocks from installed headers).  This package contains sanitized
headers instead of raw kernel headers which were present in some
previous versions of similar packages.

If possible, try to use glibc-kernheaders instead of this package.

%package -n kernel-headers-modules-%flavour
Summary: Headers and other files needed for building kernel modules
Group: System/Kernel and hardware
Requires: gcc%kgcc_version

%description -n kernel-headers-modules-%flavour
This package contains header files, Makefiles and other parts of the
Linux kernel build system which are needed to build kernel modules for
the Linux kernel package %name-%version-%release.

If you need to compile a third-party kernel module for the Linux
kernel package %name-%version-%release, install this package
and specify %kbuild_dir as the kernel source
directory.

%package -n kernel-doc-%base_flavour
Summary: Linux kernel %kversion-%base_flavour documentation
Group: System/Kernel and hardware

%description -n kernel-doc-%base_flavour
This package contains documentation files for ALT Linux kernel packages:
 * kernel-image-%base_flavour-up-%kversion-%krelease
 * kernel-image-%base_flavour-smp-%kversion-%krelease

The documentation files contained in this package may be different
from the similar files in upstream kernel distributions, because some
patches applied to the corresponding kernel packages may change things
in the kernel and update the documentation to reflect these changes.

%prep
%setup -cT -n kernel-image-%flavour-%kversion-%krelease
rm -rf kernel-source-%kernel_base_version
tar -jxf %kernel_src/kernel-source-%kernel_base_version.tar.bz2
%setup -D -T -n kernel-image-%flavour-%kversion-%krelease/kernel-source-%kernel_base_version
%patch0 -p1

# this file should be usable both with make and sh (for broken modules
# which do not use the kernel makefile system)
echo 'export GCC_VERSION=%kgcc_version' > gcc_version.inc

subst 's/EXTRAVERSION[[:space:]]*=.*/EXTRAVERSION = %kernel_extra_version-%flavour-%krelease/g' Makefile
subst 's/CC.*$(CROSS_COMPILE)gcc/CC         := $(shell echo $${GCC_USE_CCACHE:+ccache}) gcc-%kgcc_version/g' Makefile

# get rid of unwanted files resulting from patch fuzz
find . -name "*.orig" -delete -or -name "*~" -delete

%build
export ARCH=%base_arch
KernelVer=%kversion-%flavour-%krelease

echo "Building Kernel $KernelVer"

%make_build mrproper

cp -vf config-%_target_cpu .config

%make_build oldconfig
%make_build include/linux/version.h
%make_build vmlinuz
%make_build modules

echo "Kernel built $KernelVer"

%if_enabled docs
# psdocs, pdfdocs don't work yet
%make_build htmldocs
%endif

%install
export ARCH=%base_arch
KernelVer=%kversion-%flavour-%krelease

install -Dp -m644 System.map %buildroot/boot/System.map-$KernelVer
install -Dp -m644 vmlinuz \
	%buildroot/boot/vmlinuz-$KernelVer
install -Dp -m644 .config %buildroot/boot/config-$KernelVer

make modules_install INSTALL_MOD_PATH=%buildroot

install -d %buildroot%kbuild_dir
cp -a include %buildroot%kbuild_dir/include

# remove asm-* include files for other architectures
pushd %buildroot%kbuild_dir/include
for dir in asm-*; do
	[ "$dir" = "asm-generic" ] && continue
	[ "$dir" = "asm-i386" ] && continue #need for includes from x86_64
	[ "$dir" = "asm-%base_arch" ] && continue
	rm -rf -- "$dir"
done
popd

# drivers-headers install
install -d %buildroot%kbuild_dir/drivers/scsi
install -d %buildroot%kbuild_dir/drivers/char/drm
install -d %buildroot%kbuild_dir/drivers/md
install -d %buildroot%kbuild_dir/drivers/media/dvb/dvb-core
install -d %buildroot%kbuild_dir/drivers/media/video/{bt8xx,cx88,saa7134}
install -d %buildroot%kbuild_dir/drivers/usb/core
cp -a drivers/scsi/{{scsi,hosts,scsi_typedefs}.h,scsi_module.c} \
	%buildroot%kbuild_dir/drivers/scsi/
cp -a drivers/char/drm/{drm,drm_os_linux,drmP}.h \
	%buildroot%kbuild_dir/drivers/char/drm/
cp -a drivers/md/dm*.h \
	%buildroot%kbuild_dir/drivers/md/
cp -a drivers/media/dvb/dvb-core/*.h \
	%buildroot%kbuild_dir/drivers/media/dvb/dvb-core/
cp -a drivers/media/video/btcx-risc.h \
	%buildroot%kbuild_dir/drivers/media/video/
cp -a drivers/media/video/bt8xx/{bt848,bttv,bttvp}.h \
	%buildroot%kbuild_dir/drivers/media/video/bt8xx/
cp -a drivers/media/video/cx88/{cx88,cx88-reg}.h \
	%buildroot%kbuild_dir/drivers/media/video/cx88/
cp -a drivers/media/video/saa7134/{saa7134,saa7134-reg}.h \
	%buildroot%kbuild_dir/drivers/media/video/saa7134/
cp -a drivers/usb/core/*.h \
	%buildroot%kbuild_dir/drivers/usb/core/

# Install files required for building external modules (in addition to headers)
KbuildFiles="
	Makefile
	Module.symvers
	arch/%base_arch/Makefile
	arch/%base_arch/Makefile.cpu

	scripts/pnmtologo
	scripts/mod/modpost
	scripts/mkmakefile
	scripts/mkversion
	scripts/mod/mk_elfconfig
	scripts/kconfig/conf
	scripts/mkcompile_h
	scripts/makelst
	scripts/Makefile.modpost
	scripts/Makefile.modinst
	scripts/Makefile.lib
	scripts/Makefile.host
	scripts/Makefile.clean
	scripts/Makefile.build
	scripts/Makefile
	scripts/Kbuild.include
	scripts/kallsyms
	scripts/genksyms/genksyms
	scripts/basic/fixdep
	scripts/extract-ikconfig
	scripts/conmakehash
	scripts/checkversion.pl
	scripts/checkincludes.pl
	scripts/checkconfig.pl
	scripts/bin2c
	scripts/gcc-version.sh

	.config
	.kernelrelease
	gcc_version.inc
"
for f in $KbuildFiles; do
	[ -e "$f" ] || continue
	[ -x "$f" ] && mode=755 || mode=644
	install -Dp -m$mode "$f" %buildroot%kbuild_dir/"$f"
done

# Fix symlinks to kernel sources in /lib/modules
rm -f %buildroot%modules_dir/{build,source}
ln -s %kbuild_dir %buildroot%modules_dir/build

# Provide kbuild directory with old name (without %%krelease)
ln -s "$(relative %kbuild_dir %old_kbuild_dir)" %buildroot%old_kbuild_dir

# Provide kernel headers for userspace
make headers_install INSTALL_HDR_PATH=%buildroot%kheaders_dir
%ifarch x86_64
cp -a include/asm-i386 %buildroot%kheaders_dir/include/
%endif
# install documentation
%if_enabled docs
install -d %buildroot%_docdir/kernel-doc-%base_flavour-%version/
cp -a Documentation/* %buildroot%_docdir/kernel-doc-%base_flavour-%version/
find %buildroot%_docdir/kernel-doc-%base_flavour-%version/DocBook \
	-maxdepth 1 -type f -not -name '*.html' -delete
%endif # if_enabled docs

%post
%post_kernel_image %kversion-%flavour-%krelease

%preun
%preun_kernel_image %kversion-%flavour-%krelease


%post -n kernel-headers-%flavour
%post_kernel_headers %kversion-%flavour-%krelease

%postun -n kernel-headers-%flavour
%postun_kernel_headers %kversion-%flavour-%krelease

%files
/boot/vmlinuz-%kversion-%flavour-%krelease
/boot/System.map-%kversion-%flavour-%krelease
/boot/config-%kversion-%flavour-%krelease
%modules_dir
%exclude %modules_dir/build


%files -n kernel-headers-%flavour
%kheaders_dir

%files -n kernel-headers-modules-%flavour
%kbuild_dir
%old_kbuild_dir
%dir %modules_dir
%modules_dir/build

%if_enabled docs
%files -n kernel-doc-%base_flavour
%doc %_docdir/kernel-doc-%base_flavour-%version
%endif

%changelog
* Tue Jun 10 2008 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt6.M40.3
- fix CVE-2008-2358

* Wed May 07 2008 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt6.M40.2
- 3.1.4 

* Tue Mar 04 2008 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt6.M40.1
- build for branch 4.0 

* Mon Feb 11 2008 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt6
- rebase to std-alt12

* Fri Feb 08 2008 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt5.1
- fix headers for x86_64

* Thu Feb 07 2008 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt5
- rebase to std-alt11  kernel

* Mon Nov 26 2007 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt4
- 3.1.2

* Tue Oct 23 2007 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt3
- 3.1.1

* Fri Aug 24 2007 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt2
- new build scheme
- added all paches from std kernel
- added RH cluster support

* Mon May 21 2007 Michail Yakushin <silicium@altlinux.ru> 2.6.18-alt1
- 3.1.0 

* Thu Dec 21 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt7
- 3.0.4

* Mon Nov 06 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt6
- fix build for x86_64

* Wed Oct 18 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt5
- new xen version 3.0.3
- enabled PAE 

* Tue Oct 17 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt4
- fix build for x86_64

* Fri Oct 06 2006 Michail Yakushin <silicium@altlinux.ru> 2.6.16-alt3
- change build scheme
- stable release

* Thu Jun 29 2006 Alex Yustasov <yust@altlinux.ru> 2.6.16-alt2
- fixed config for i586: 
    CONFIG_HIGHMEM4G=y, turned off CONFIG_PAE and CONFIG_HIGHMEM64G

* Thu Jun 08 2006 Alex Yustasov <yust@altlinux.ru> 2.6.16-alt1
- xen-2.6.16-3.0.2-3

* Mon Jul 04 2005 Alex Yustasov <yust@altlinux.ru> 2.6.12-alt1
- initial build
